Index: src/UIElements/CommandLineUI/Query/EmptyCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/EmptyCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/EmptyCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,40 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * EmptyCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <iostream>
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::EmptyCommandLineQuery::EmptyCommandLineQuery(string title, string _description) :
+    Dialog::EmptyQuery(title, _description)
+{}
+
+CommandLineDialog::EmptyCommandLineQuery::~EmptyCommandLineQuery() {}
+
+bool CommandLineDialog::EmptyCommandLineQuery::handle() {
+  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
+  return true;
+}
+
Index: src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/FileCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FileCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::FileCommandLineQuery::FileCommandLineQuery(string title, string _description) :
+    Dialog::FileQuery(title, _description)
+{}
+
+CommandLineDialog::FileCommandLineQuery::~FileCommandLineQuery() {}
+
+bool CommandLineDialog::FileCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< boost::filesystem::path >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing string for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/IntCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IntCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(string title, string _description) :
+    Dialog::IntQuery(title, _description)
+{}
+
+CommandLineDialog::IntCommandLineQuery::~IntCommandLineQuery() {}
+
+bool CommandLineDialog::IntCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing integer for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/IntsCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IntsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::IntsCommandLineQuery::IntsCommandLineQuery(string title, string _description) :
+    Dialog::IntsQuery(title, _description)
+{}
+
+CommandLineDialog::IntsCommandLineQuery::~IntsCommandLineQuery() {}
+
+bool CommandLineDialog::IntsCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing integers for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/MoleculeCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,47 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculeCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(string title, string _description) :
+    Dialog::MoleculeQuery(title, _description)
+{}
+
+CommandLineDialog::MoleculeCommandLineQuery::~MoleculeCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculeCommandLineQuery::handle() {
+  int IdxOfMol = -1;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing molecule for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/MoleculesCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,52 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MoleculesCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+#include "World.hpp"
+
+CommandLineDialog::MoleculesCommandLineQuery::MoleculesCommandLineQuery(string title, string _description) :
+    Dialog::MoleculesQuery(title, _description)
+{}
+
+CommandLineDialog::MoleculesCommandLineQuery::~MoleculesCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculesCommandLineQuery::handle() {
+  std::vector<int> IdxOfMol;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<int> >();
+    for (std::vector<int>::iterator iter = IdxOfMol.begin(); iter != IdxOfMol.end(); ++iter) {
+      temp = World::getInstance().getMolecule(MoleculeById(*iter));
+      if (temp)
+        tmp.push_back(temp);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing molecules for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/StringCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * StringCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(string title, string _description) :
+    Dialog::StringQuery(title, _description)
+{}
+
+CommandLineDialog::StringCommandLineQuery::~StringCommandLineQuery() {}
+
+bool CommandLineDialog::StringCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<string>();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing string for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,43 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * StringsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+
+CommandLineDialog::StringsCommandLineQuery::StringsCommandLineQuery(string title, string _description) :
+    Dialog::StringsQuery(title, _description)
+{}
+
+CommandLineDialog::StringsCommandLineQuery::~StringsCommandLineQuery() {}
+
+bool CommandLineDialog::StringsCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< vector<string> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing strings for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,56 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * VectorCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Actions/Values.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Box.hpp"
+#include "World.hpp"
+
+CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(string title, bool _check, string _description) :
+    Dialog::VectorQuery(title,_check, _description)
+{}
+
+CommandLineDialog::VectorCommandLineQuery::~VectorCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorCommandLineQuery::handle() {
+  VectorValue temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as< VectorValue >();
+    tmp[0] = temp.x;
+    tmp[1] = temp.y;
+    tmp[2] = temp.z;
+    if ((check) && (!World::getInstance().getDomain().isInside(tmp))) {
+      DoeLog(1) && (eLog() << Verbose(1) << "Vector " << tmp << " would be outside of box domain." << endl);
+      return false;
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing vector for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,58 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * VectorsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <vector>
+
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "Actions/Values.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "CommandLineParser.hpp"
+#include "World.hpp"
+
+CommandLineDialog::VectorsCommandLineQuery::VectorsCommandLineQuery(string title, bool _check, string _description) :
+    Dialog::VectorsQuery(title,_check, _description)
+{}
+
+CommandLineDialog::VectorsCommandLineQuery::~VectorsCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorsCommandLineQuery::handle() {
+  std::vector<VectorValue> temporary;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temporary = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<VectorValue> >();
+    for(std::vector<VectorValue>::iterator iter = temporary.begin(); iter != temporary.end(); ++iter) {
+      temp[0] = (*iter).x;
+      temp[1] = (*iter).y;
+      temp[2] = (*iter).z;
+      if ((!check) || (World::getInstance().getDomain().isInside(temp)))
+        tmp.push_back(temp);
+      else
+        DoeLog(1) && (eLog() << Verbose(1) << "Vector " << temp << " would be outside of box domain." << endl);
+    }
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing vectors for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 57a6ea1a91e89f394ecb0bdcf58b45e3ca1587e9)
+++ src/UIElements/Dialog.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -23,12 +23,13 @@
 #include "Actions/ValueStorage.hpp"
 
+#include "Helpers/Log.hpp"
 #include "Helpers/Verbose.hpp"
-#include "atom.hpp"
-#include "Box.hpp"
-#include "element.hpp"
-#include "molecule.hpp"
-#include "LinearAlgebra/BoxVector.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include "LinearAlgebra/Matrix.hpp"
+
+class Atom;
+class Box;
+class element;
+class Matrix;
+class molecule;
+class Vector;
 
 using namespace std;
@@ -185,240 +186,5 @@
 }
 
-/****************** Query types Infrastructure **************************/
-
-// Base class
-Dialog::Query::Query(string _title, string _description) :
-    title(_title),
-    description(_description)
-{}
-
-Dialog::Query::~Query() {}
-
-const std::string Dialog::Query::getTitle() const{
-  return title;
-}
-
-const std::string Dialog::Query::getDescription() const{
-  return description;
-}
-// empty Queries
-
-Dialog::EmptyQuery::EmptyQuery(string title, std::string description) :
-    Query(title, description)
-{}
-
-Dialog::EmptyQuery::~EmptyQuery() {}
-
-void Dialog::EmptyQuery::setResult() {
-}
-
-// Int Queries
-
-Dialog::IntQuery::IntQuery(string title, std::string description) :
-    Query(title, description)
-{}
-
-Dialog::IntQuery::~IntQuery() {}
-
-void Dialog::IntQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Ints Queries
-
-Dialog::IntsQuery::IntsQuery(string title, std::string description) :
-    Query(title, description)
-{}
-
-Dialog::IntsQuery::~IntsQuery() {}
-
-void Dialog::IntsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Bool Queries
-
-Dialog::BooleanQuery::BooleanQuery(string title,std::string description) :
-    Query(title, description)
-{}
-
-Dialog::BooleanQuery::~BooleanQuery() {}
-
-void Dialog::BooleanQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// String Queries
-
-Dialog::StringQuery::StringQuery(string title,std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::StringQuery::~StringQuery() {};
-
-void Dialog::StringQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Strings Queries
-
-Dialog::StringsQuery::StringsQuery(string title,std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::StringsQuery::~StringsQuery() {};
-
-void Dialog::StringsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Double Queries
-
-Dialog::DoubleQuery::DoubleQuery(string title, std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::DoubleQuery::~DoubleQuery() {};
-
-void Dialog::DoubleQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Doubles Queries
-
-Dialog::DoublesQuery::DoublesQuery(string title, std::string _description) :
-    Query(title, _description)
-{}
-
-Dialog::DoublesQuery::~DoublesQuery() {};
-
-void Dialog::DoublesQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-
-// Atom Queries
-
-Dialog::AtomQuery::AtomQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::AtomQuery::~AtomQuery() {}
-
-void Dialog::AtomQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Atoms Queries
-
-Dialog::AtomsQuery::AtomsQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::AtomsQuery::~AtomsQuery() {}
-
-void Dialog::AtomsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Molecule Queries
-
-Dialog::MoleculeQuery::MoleculeQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::MoleculeQuery::~MoleculeQuery() {}
-
-void Dialog::MoleculeQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Molecules Queries
-
-Dialog::MoleculesQuery::MoleculesQuery(string title, std::string _description) :
-    Query(title, _description),
-    tmp(0)
-{}
-
-Dialog::MoleculesQuery::~MoleculesQuery() {}
-
-void Dialog::MoleculesQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Vector Queries
-
-Dialog::VectorQuery::VectorQuery(std::string title,bool _check, std::string _description) :
-  Query(title, _description),
-  check(_check)
-{}
-
-Dialog::VectorQuery::~VectorQuery()
-{}
-
-void Dialog::VectorQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Vectors Queries
-
-Dialog::VectorsQuery::VectorsQuery(std::string title,bool _check, std::string _description) :
-  Query(title, _description),
-  check(_check)
-{}
-
-Dialog::VectorsQuery::~VectorsQuery()
-{}
-
-void Dialog::VectorsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Box Queries
-
-Dialog::BoxQuery::BoxQuery(std::string title, std::string _description) :
-  Query(title, _description)
-{}
-
-Dialog::BoxQuery::~BoxQuery()
-{}
-
-void Dialog::BoxQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Element Queries
-Dialog::ElementQuery::ElementQuery(std::string title, std::string _description) :
-  Query(title, _description)
-  {}
-
-Dialog::ElementQuery::~ElementQuery(){}
-
-void Dialog::ElementQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// Elements Queries
-Dialog::ElementsQuery::ElementsQuery(std::string title, std::string _description) :
-  Query(title, _description)
-  {}
-
-Dialog::ElementsQuery::~ElementsQuery(){}
-
-void Dialog::ElementsQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
-
-// File Queries
-Dialog::FileQuery::FileQuery(std::string title, std::string _description) :
-  Query(title, _description)
-  {}
-
-Dialog::FileQuery::~FileQuery(){}
-
-void Dialog::FileQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
-}
+/************************** Query Infrastructure ************************/
+/*       ---> shifted to folder Query                                   */
+/************************************************************************/
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 57a6ea1a91e89f394ecb0bdcf58b45e3ca1587e9)
+++ src/UIElements/Makefile.am	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -41,4 +41,23 @@
   ${TEXTUISOURCE} \
   ${VIEWSOURCE} \
+  Query/AtomQuery.cpp \
+  Query/AtomsQuery.cpp \
+  Query/BooleanQuery.cpp \
+  Query/BoxQuery.cpp \
+  Query/DoubleQuery.cpp \
+  Query/DoublesQuery.cpp \
+  Query/ElementQuery.cpp \
+  Query/ElementsQuery.cpp \
+  Query/EmptyQuery.cpp \
+  Query/FileQuery.cpp \
+  Query/IntQuery.cpp \
+  Query/IntsQuery.cpp \
+  Query/MoleculeQuery.cpp \
+  Query/MoleculesQuery.cpp \
+  Query/Query.cpp \
+  Query/StringQuery.cpp \
+  Query/StringsQuery.cpp \
+  Query/VectorQuery.cpp \
+  Query/VectorsQuery.cpp \
   Dialog.cpp \
   MainWindow.cpp
@@ -54,4 +73,22 @@
 
 TEXTUISOURCE = \
+  TextUI/Query/AtomsTextQuery.cpp \
+  TextUI/Query/AtomTextQuery.cpp \
+  TextUI/Query/BooleanTextQuery.cpp \
+  TextUI/Query/BoxTextQuery.cpp \
+  TextUI/Query/DoubleTextQuery.cpp \
+  TextUI/Query/DoublesTextQuery.cpp \
+  TextUI/Query/ElementTextQuery.cpp \
+  TextUI/Query/ElementsTextQuery.cpp \
+  TextUI/Query/EmptyTextQuery.cpp \
+  TextUI/Query/FileTextQuery.cpp \
+  TextUI/Query/IntTextQuery.cpp \
+  TextUI/Query/IntsTextQuery.cpp \
+  TextUI/Query/MoleculesTextQuery.cpp \
+  TextUI/Query/MoleculeTextQuery.cpp \
+  TextUI/Query/StringTextQuery.cpp \
+  TextUI/Query/StringsTextQuery.cpp \
+  TextUI/Query/VectorTextQuery.cpp \
+  TextUI/Query/VectorsTextQuery.cpp \
   TextUI/TextDialog.cpp \
   TextUI/TextStatusIndicator.cpp \
@@ -65,4 +102,22 @@
 
 COMMANDLINEUISOURCE = \
+  CommandLineUI/Query/AtomCommandLineQuery.cpp \
+  CommandLineUI/Query/AtomsCommandLineQuery.cpp \
+  CommandLineUI/Query/BooleanCommandLineQuery.cpp \
+  CommandLineUI/Query/BoxCommandLineQuery.cpp \
+  CommandLineUI/Query/DoubleCommandLineQuery.cpp \
+  CommandLineUI/Query/DoublesCommandLineQuery.cpp \
+  CommandLineUI/Query/ElementCommandLineQuery.cpp \
+  CommandLineUI/Query/ElementsCommandLineQuery.cpp \
+  CommandLineUI/Query/EmptyCommandLineQuery.cpp \
+  CommandLineUI/Query/FileCommandLineQuery.cpp \
+  CommandLineUI/Query/IntCommandLineQuery.cpp \
+  CommandLineUI/Query/IntsCommandLineQuery.cpp \
+  CommandLineUI/Query/MoleculeCommandLineQuery.cpp \
+  CommandLineUI/Query/MoleculesCommandLineQuery.cpp \
+  CommandLineUI/Query/StringCommandLineQuery.cpp \
+  CommandLineUI/Query/StringsCommandLineQuery.cpp \
+  CommandLineUI/Query/VectorCommandLineQuery.cpp \
+  CommandLineUI/Query/VectorsCommandLineQuery.cpp \
   CommandLineUI/CommandLineDialog.cpp \
   CommandLineUI/CommandLineStatusIndicator.cpp \
Index: src/UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/Qt4/Pipe/AtomQtQueryPipe.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,45 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AtomQtQueryPipe.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include <Qt/qcombobox.h>
+
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Helpers/MemDebug.hpp"
+#include "World.hpp"
+
+
+AtomQtQueryPipe::AtomQtQueryPipe(atom **_content, QtDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
+
+AtomQtQueryPipe::~AtomQtQueryPipe()
+{}
+
+void AtomQtQueryPipe::update(int newIndex) {
+  QVariant data = theBox->itemData(newIndex);
+  int idx = data.toInt();
+  (*content) = World::getInstance().getAtom(AtomById(idx));
+  dialog->update();
+}
+
+
Index: src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/Qt4/Pipe/AtomsQtQueryPipe.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,75 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AtomsQtQueryPipe.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include <vector>
+
+#include <Qt/qlistwidget.h>
+
+#include "Descriptors/AtomIdDescriptor.hpp"
+#include "Helpers/MemDebug.hpp"
+#include "World.hpp"
+
+
+AtomsQtQueryPipe::AtomsQtQueryPipe(std::vector<atom *>*_content, QtDialog *_dialog, QListWidget *_theList) :
+  content(_content),
+  dialog(_dialog),
+  theList(_theList)
+{}
+
+AtomsQtQueryPipe::~AtomsQtQueryPipe()
+{}
+
+void AtomsQtQueryPipe::update() {
+  // clear target and put all atoms therein
+  (*content).clear();
+  for (std::set<atom *>::iterator iter = currentList.begin(); iter != currentList.end(); ++iter)
+    (*content).push_back(*iter);
+  dialog->update();
+}
+
+void AtomsQtQueryPipe::add() {
+  QList<QListWidgetItem *> items = theList->selectedItems();
+  for (QList<QListWidgetItem *>::iterator iter = items.begin();iter != items.end();++iter) {
+    const int index = (*iter)->text().toInt();
+    atom *Walker = World::getInstance().getAtom(AtomById(index));
+    if (Walker) {
+      (*content).push_back(Walker);
+      currentList.insert(Walker);
+      if (lookup.find(index) != lookup.end())
+        lookup.insert(pair<int, atom*>(index, Walker));
+    }
+  }
+  update();
+}
+
+void AtomsQtQueryPipe::remove() {
+  QList<QListWidgetItem *> items = theList->selectedItems();
+  for (QList<QListWidgetItem *>::iterator iter = items.begin();iter != items.end();++iter) {
+    const int index = (*iter)->text().toInt();
+    atom *Walker = World::getInstance().getAtom(AtomById(index));
+    if (Walker) {
+      currentList.erase(Walker);
+    }
+  }
+  update();
+}
+
+
Index: src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp
===================================================================
--- src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/Qt4/Pipe/BooleanQtQueryPipe.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
@@ -0,0 +1,37 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * BooleanQtQueryPipe.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "UIElements/Qt4/QtDialog.hpp"
+
+#include <Qt/qcombobox.h>
+
+
+BooleanQtQueryPipe::BooleanQtQueryPipe(const bool *_content, QtDialog *_dialog, QComboBox *_booleanComboBox) :
+  content(_content),
+  dialog(_dialog),
+  booleanComboBox(_booleanComboBox)
+{}
+
+BooleanQtQueryPipe::~BooleanQtQueryPipe()
+{}
+
+void BooleanQtQueryPipe::update() {
+  dialog->update();
+}
+
